import urllib
from xml.dom import minidom
from Tkinter import *
import tkFileDialog
import os.path

class AdventureDownloader(Tk):
    def __init__(self, *args, **kwargs):
        Tk.__init__(self, *args, **kwargs)
        self.placeWidgets()
    def placeWidgets(self):
        Label(self, text="Enter the URL or ID of an adventure:", anchor=W).pack(fill=X)
        self.textField = Entry(self)
        self.textField.pack(fill=X)
        self.textField.bind("<Return>", self.go)
        self.button = Button(self, text="Go!", command=self.go)
        self.button.pack()
    def askForSaveDir(self):
        initialdir = os.path.expanduser('~')
        if initialdir == '~':
            initialdir = os.getcwd()
        self.dirname = tkFileDialog.askdirectory(parent=self,
                                                 initialdir=initialdir,
                                                 title="Choose a directory to save PNGs to")
    def go(self, event=None):
        self.askForSaveDir()
        if self.dirname in ('', None):
            return
        inp = self.textField.get()
        if inp.isdigit():
            id = inp
        else:
            # We'll assume it's a URL
            idx = inp.find("sast-")
            id = inp[idx+5:idx+17]
        url = "http://www.spore.com/static/model/%s/%s/%s/%s.xml" % (id[0:3], id[3:6], id[6:9], id)
        urldoc = urllib.urlopen(url)
        doc = minidom.parse(urldoc)
        urldoc.close()
        for assetTag in doc.getElementsByTagName("assets")[0].childNodes:
            id = assetTag.firstChild.data
            url = "http://www.spore.com/static/thumb/%s/%s/%s/%s.png" % (id[0:3], id[3:6], id[6:9], id)
            try:
                urldoc = urllib.urlopen(url)
                fout = open(os.path.join(self.dirname, id+'.png'), 'wb')
                fout.write(urldoc.read())
                fout.close()
                urldoc.close()
            except IOError:
                continue

AdventureDownloader().mainloop()
